/*
* ItemMenu.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
#pragma once

//====================================================================================
// QT Includes
//====================================================================================
#include <QtCore/QObject>
#include <QtCore/QPoint>

//====================================================================================
// Project Includes
//====================================================================================
#include "idgraphicsitem.h"

//====================================================================================
// Local Includes
//====================================================================================

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class QAction;
class QMenu;

class ItemMenu : public QObject
{
  Q_OBJECT
private:
  QAction *actionLocked;
  QAction *actionResize;
  QAction *actionBring_Forward;
  QAction *actionSend_Backwards;
  QMenu *menuMenuBar;
  iDGraphicsItem * currentItem;
  public slots:
    void lockedClicked(bool checked);
    void resizeClicked();
    void bringForwardsClicked();
    void sendBackwardsClicked();

public:
  ItemMenu(iDGraphicsItem* item);
  virtual ~ItemMenu(void);
  void retranslateUi();
  void popUp(QPoint *pos);
};
