/*
* dialog.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtGui/QDialog>

//====================================================================================
// Project Includes
//====================================================================================

//====================================================================================
// Local Includes
//====================================================================================
#include "ui_connect.h"

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------


#ifndef DIALOG_H
#define DIALOG_H


class JoinSessionDialog : public QDialog
{
  Q_OBJECT

public:
  JoinSessionDialog(QWidget *parent = 0, Qt::WFlags flags = 0);
  virtual ~JoinSessionDialog();

  public slots:
    void accept();
    void reject();
    void textChang(const QString &text);

private:
  Ui::StartConnection dialog;
};

class StartSessionDialog : public QDialog
{
  Q_OBJECT

public:
  StartSessionDialog(QWidget *parent = 0, Qt::WFlags flags = 0);
  ~StartSessionDialog();

  public slots:
    void accept();
    void reject();
    void textChang(const QString &text);

private:
  Ui::StartConnection dialog;
};



#endif // DIALOG_H
