/*
* gui.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/

#ifndef __GUI_H__
#define __GUI_H__

//====================================================================================
// QT Includes
//====================================================================================
#include <QtGui/QWidget>
#include <QtGui/QApplication>
//====================================================================================
// Project Includes
//====================================================================================

//====================================================================================
// Local Includes
//====================================================================================
#include "mainwindow.h"
#include "dialog.h"
#include "tabula.h"


//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
//
//class MainWindow; this line should be uncommented, and the above MainWindow.h #include removed.
// Main gui class.
class GUI : public QWidget
{
  Q_OBJECT
public:
  static GUI& GetSingleton()
  {
    if(!myself)
    {
      myself = new GUI();
    }

    return *myself;
  }
  MainWindow window;
  /// Create and open the GUI.
  static void Open();

  /// Clean up and close the GUI.
  static void Close();


  public slots:
    /// Join session button.
    void OnJoinClicked();

    /// Start session button.
    void OnStartClicked();

private:
  /// Singleton object pointer.
  static GUI* myself;

  /// Init the GUI.
  void Init();

  /// Top level window.


  /// QT Dialogs
  JoinSessionDialog joinSession;
  StartSessionDialog startSession;
};

#endif // __GUI_H__
