/*
* tabula.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/

#ifndef __TABULA_H__
#define __TABULA_H__

//====================================================================================
// QT Includes
//====================================================================================

//====================================================================================
// Project Includes
//====================================================================================

//====================================================================================
// Local Includes
//====================================================================================

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class QApplication;
class QSettings;
class Logger;
class QDir;
#include "logger/logger.h"
class Tabula
{
public:
  Tabula();
  ~Tabula();

  static Tabula& GetSingleton()
  {
    if(!myself)
    {
      if(!app)
      {
        DBG(0,"QApplication must be created before everything else!\n");
        exit(1);
      }
      myself = new Tabula();
    }

    return *myself;
  }

  static QApplication* GetQApplication()
  {
    return app;
  }

  static int Run(int argc, char** argv);

private:
  /// Singleton object pointers.
  static Tabula* myself;
  static QApplication* app;

  /// Start the program.
  bool Start();

  /// Settings object for the whole project.
  static QSettings* settings;

  /// Logging object.
  static Logger* logger;

  /// Path to the directory this executable is living in.
  static QDir* pathToExec;

  /// Set up the path to this executable.
  static void setPathToExec( const char* progname );

  /// Current session.
  iSession* session;
};

#endif // __TABULA_H__

