/*
* icontext.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Dan Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/

#ifndef __I_CONTEXT_H__
#define __I_CONTEXT_H__

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class Event;
class QGraphicsItem;
class QGraphicsSceneMouseEvent;
class QPointF;
struct iContextCallback;
struct iDesc;
struct iDGraphicsItem;

//====================================================================================
// Interface
//====================================================================================

struct iContext
{
	virtual bool MousePressEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent) = 0;
	virtual bool MouseReleaseEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent) = 0;
	virtual bool MouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent, QPointF& newPos, Event*& newEvent) = 0;
	virtual void MousePressCallBack(iDGraphicsItem *item) = 0;
	virtual void MouseReleaseCallBack(iDGraphicsItem *item) = 0;
	virtual void MouseMoveCallBack(iDGraphicsItem *item) = 0;
};

#endif // __I_CONTEXT_H__
