/*
* idescgraphicsitem.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Dan Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/

#ifndef __I_DGRAPHICS_ITEM__
#define __I_DGRAPHICS_ITEM__

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class Draw;
class Modify;
class QDialog;
class QPointF;
struct iContextCallback;
struct iDesc;

//====================================================================================
// Interface
//====================================================================================

struct iDGraphicsItem
{
	virtual void Modify(const iDesc* desc) = 0;
	virtual iDesc* GetDesc() = 0;
	virtual void Erase() = 0;
  virtual Draw* GetEvent() = 0;
  virtual void SetEvent(Draw* e) = 0;
  virtual void OnItemSetup() { }
  virtual iContextCallback* GetCallback() = 0;
  virtual void SetLock(bool lock) = 0;
  virtual bool GetLock() = 0;
  virtual void BringForward() = 0;
  virtual void SendBack() = 0;
  virtual void ResizeStart( bool sendTempEvents ) = 0;
  virtual void AdjustHorizontal(int value) = 0;
  virtual void AdjustVertical(int value) = 0;
  virtual void ResizeEnd(QDialog *dialog, int x, int y) = 0;
};

#endif // __I_DGRAPHICS_ITEM__
