/*
* ilog.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Dan Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/

#ifndef __I_LOG_H__
#define __I_LOG_H__

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class Person;
class Timestamp;
struct iNetwork;
struct SystemAddress;
//====================================================================================
// Interface
//====================================================================================

struct iLog
{
  virtual void SetOwner(Person* logOwner) = 0;
  virtual Person* GetOwner() = 0;
  virtual void ForwardEvents(iNetwork* network, SystemAddress& target, const Timestamp* ts = 0) = 0;
  virtual const Timestamp* GetLastTimestamp() = 0;
};

#endif // __I_LOG_H__
