/*
* isession.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Dan Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/

#ifndef __I_SESSION_H__
#define __I_SESSION_H__

//====================================================================================
// Project Includes
//====================================================================================
#include <vector>

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------

class Person;
struct SystemAddress;
namespace RakNet
{
  class BitStream;
}

//====================================================================================
// Interface
//====================================================================================

struct iSession
{
  virtual void AddMember(Person* person) = 0;
  virtual bool RemoveMember(const Person& person) = 0;
  virtual unsigned int FindMember(const Person& person) const = 0;
  virtual Person* FindMember(const char* username) const = 0;
  virtual Person* FindMember(const SystemAddress& address) const = 0;
  virtual Person* FindMember(const short id) const = 0;
	virtual const Person* Deserialize( RakNet::BitStream& bs ) const = 0;

  virtual std::vector<Person*>::const_iterator GetMembers() const = 0;
  virtual size_t GetMemberCount() const = 0;
};

#endif // __I_SESSION_H__
