/*
* ContextErase.cpp
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtGui/QAbstractGraphicsShapeItem>
#include <QtGui/QGraphicsSceneMouseEvent>
#include <QtGui/QGraphicsScene>
#include <QtGui/QGraphicsItem>
//====================================================================================
// Project Includes
//====================================================================================
#include <iostream>
#include "icontextcallback.h"
#include "idgraphicsitem.h"
#include "log/delete.h"
#include "log/draw.h"
#include "network/network.h"
#include "raknet/BitStream.h"
//====================================================================================
// Local Includes
//====================================================================================
#include "ContextErase.h"
//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------

using namespace RakNet;

ContextErase::ContextErase(void): currentHover(0), currentLineHover(0), drawing(false)
{
}

ContextErase::~ContextErase(void)
{
}

bool ContextErase::MousePressEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent)
{
  return false;
}
bool ContextErase::MouseReleaseEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent)
{
  return false;
}
bool ContextErase::MouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent, QPointF& newPos, Event*& newEvent)
{
  return false;
}

void ContextErase::MousePressCallBack(iDGraphicsItem *item)
{
  item->GetCallback()->EraseObjects();
}

void ContextErase::MouseReleaseCallBack(iDGraphicsItem *item)
{
}

void ContextErase::MouseMoveCallBack(iDGraphicsItem *item)
{
}
