#pragma once
/*
* ContextLine.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtCore/QtGlobal>
//====================================================================================
// Project Includes
//====================================================================================
#include "icontext.h"
//====================================================================================
// Local Includes
//====================================================================================

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class DGraphicsLineItem;
class QGraphicsSceneMouseEvent;

class ContextLine :
  public iContext
{
public:
  ContextLine(void);
  ~ContextLine(void);
  virtual bool MousePressEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent);
  virtual bool MouseReleaseEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent);
  virtual bool MouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent, QPointF& newPos, Event*& newEvent);
  virtual void MousePressCallBack(iDGraphicsItem *item);
  virtual void MouseMoveCallBack(iDGraphicsItem *item);
  virtual void MouseReleaseCallBack(iDGraphicsItem *item);

private:
  iDesc * currentItem;
  qreal currentItemX;
  qreal currentItemY;
  qreal currentItemWidth;
  qreal currentItemHeight;
  bool drawing;
};
