/*
* ContextText.cpp
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtGui/QGraphicsSceneMouseEvent>
#include <QtGui/QGraphicsTextItem>

//====================================================================================
// Project Includes
//====================================================================================
#include "icontextcallback.h"
#include "log/draw.h"
#include "log/modify.h"
#include <iostream>
//====================================================================================
// Local Includes
//====================================================================================
#include "DGraphicsTextItem.h"
#include "DescText.h"
#include "ContextText.h"
//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------


ContextText::ContextText(void) : drawing(false), currentItem(0)
{
  currentItemWidth = 100; // Arbitrary number which looks good.
}

ContextText::~ContextText(void)
{
}

bool ContextText::MousePressEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent)
{
  drawing = true;

  // Get start pos & create temp
  QPointF pos( mouseEvent->buttonDownScenePos(mouseEvent->button()) );
  currentItemX = pos.x();
  currentItemY = pos.y();
  newEvent = new TempDraw(new DescText("Enter Text", currentItemX, currentItemY, currentItemWidth, 0, true));

  return true;
}


bool ContextText::MouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent, QPointF& newPos, Event*& newEvent)
{
  return false;
}

bool ContextText::MouseReleaseEvent(QGraphicsSceneMouseEvent *mouseEvent, Event*& newEvent)
{
  drawing = false;

  // Finalise text
  newEvent = new Draw(new DescText("Enter Text", currentItemX, currentItemY, currentItemWidth, 0, true));

  return false;
}

void ContextText::MousePressCallBack(iDGraphicsItem *item)
{
  item->GetCallback()->ClearSelection();
}

void ContextText::MouseReleaseCallBack(iDGraphicsItem *item)
{
}

void ContextText::MouseMoveCallBack(iDGraphicsItem *item)
{
  item->GetCallback()->ClearSelection();
}
