#pragma once
/*
* DGraphicsTextItem.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtGui/QGraphicsTextItem>
#include <QtCore/QString>

//====================================================================================
// Project Includes
//====================================================================================
#include "idgraphicsitem.h"
//====================================================================================
// Local Includes
//====================================================================================

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
struct iContextCallback;


class DGraphicsTextItem : public QGraphicsTextItem, public iDGraphicsItem
{
public:
  DGraphicsTextItem(const QString &text, iContextCallback* callback);
  ~DGraphicsTextItem(void);

  void Modify(const iDesc* desc);
  iDesc* GetDesc();
  void Erase();
  void mousePressEvent(QGraphicsSceneMouseEvent *mouseEvent);
  void mouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent);
  void mouseReleaseEvent(QGraphicsSceneMouseEvent *mouseEvent);
  void mouseDoubleClickEvent(QGraphicsSceneMouseEvent *mouseEvent);
  void focusOutEvent(QFocusEvent *focusEvent);
  void hoverLeaveEvent(QGraphicsSceneHoverEvent *sceneEvent);
  void hoverEnterEvent(QGraphicsSceneHoverEvent *sceneEvent);
  virtual Draw* GetEvent() { return draw; }
  virtual void SetEvent(Draw* d);
  virtual void OnItemSetup();
  virtual iContextCallback* GetCallback() { return callback; }
  void SetLock(bool lock);
  bool GetLock();
  void BringForward();
  void SendBack();
  void ResizeStart( bool sendTempEvents );
  void AdjustHorizontal(int value);
  void AdjustVertical(int value);
  void ResizeEnd(QDialog *dialog, int x, int y);
private:
  iContextCallback* callback;
  Draw* draw;
  bool locked;
};
