/*
* DescGraphic.cpp
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtXml/QXmlStreamWriter>
//====================================================================================
// Project Includes
//====================================================================================
#include "raknet/BitStream.h"
#include "log/draw.h"
//====================================================================================
// Local Includes
//====================================================================================
#include "DescGraphic.h"
//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
using namespace RakNet;

DescGraphic::DescGraphic(short x, short y, short width, short height, short zOrder, bool locked)
: x(x), y(y), width(width), height(height), zOrder(zOrder), locked(locked)
{
}

DescGraphic::DescGraphic(BitStream& bs)
{
  // Read into locals
  bs.ReadCompressed(x);
  bs.ReadCompressed(y);
  bs.ReadCompressed(width);
  bs.ReadCompressed(height);
  bs.ReadCompressed(zOrder);
  bs.ReadCompressed(locked);
}

DescGraphic::~DescGraphic(void)
{
}

void DescGraphic::Serialise(RakNet::BitStream &bs) const
{
  // Write locals to BitStream
  bs.WriteCompressed(x);
  bs.WriteCompressed(y);
  bs.WriteCompressed(width);
  bs.WriteCompressed(height);
  bs.WriteCompressed(zOrder);
  bs.WriteCompressed(locked);

}

void DescGraphic::Serialise(QXmlStreamWriter& xml) const
{
  // Write locals as XML
  xml.writeAttribute( "x", QString::number( x ) );
  xml.writeAttribute( "y", QString::number( y ) );
  xml.writeAttribute( "width", QString::number( width ) );
  xml.writeAttribute( "height", QString::number( height ) );
  xml.writeAttribute( "zOrder", QString::number( zOrder ) );
  xml.writeAttribute( "locked", QString::number( locked ) );
}

DescGraphic::DescGraphic( QXmlStreamReader& xml )
{
  // Extract locals from XML
  x = xml.attributes().value("x").toString().toDouble();
  y = xml.attributes().value("y").toString().toDouble();
  width = xml.attributes().value("width").toString().toDouble();
  height = xml.attributes().value("height").toString().toDouble();
  zOrder = xml.attributes().value("zOrder").toString().toDouble();
  locked = xml.attributes().value("locked").toString().toInt();
}
