#pragma once
/*
* DescGraphic.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtCore/QtGlobal>
//====================================================================================
// Project Includes
//====================================================================================
#include "idesc.h"
//====================================================================================
// Local Includes
//====================================================================================

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class QXmlStreamReader;

class DescGraphic :	public iDesc
{
public:
  DescGraphic(short x, short y, short width, short height, short zOrder, bool locked);
  DescGraphic(RakNet::BitStream& bs);
  DescGraphic(QXmlStreamReader& xml);
  ~DescGraphic(void);

  inline short GetX() const { return x; }
  inline short GetY() const { return y; }
  inline short GetWidth() const { return width; }
  inline short GetHeight() const { return height; }
  inline short GetZOrder() const { return zOrder; }
  inline bool GetLocked() const { return locked; }


  virtual void Serialise(RakNet::BitStream& bs) const;
  virtual void Serialise(QXmlStreamWriter& xml) const;
  virtual iDGraphicsItem* GetFactory(iContextCallback* callback, Draw* draw) { return NULL; }

protected:
  short x;
  short y;
  short width;
  short height;
  short zOrder;
  bool locked;
};
