#pragma once
/*
* DescRect.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtCore/QtGlobal>
//====================================================================================
// Project Includes
//====================================================================================

//====================================================================================
// Local Includes
//====================================================================================
#include "DescGraphic.h"
//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class DGraphicsRectItem;

class DescRect : public DescGraphic
{
public:
  DescRect(qreal x, qreal y, qreal width, qreal height, qreal zOrder, bool locked);
  DescRect(RakNet::BitStream& bs);
  DescRect(QXmlStreamReader& bs);
  ~DescRect(void);

  virtual void Serialise(RakNet::BitStream& bs) const;
  virtual void Serialise(QXmlStreamWriter& xml) const;
  virtual iDGraphicsItem* GetFactory(iContextCallback* callback, Draw* draw);
  virtual inline QString GetStringDesc() const { return QString( "rectangle" ); }

private:
  DGraphicsRectItem* factory;
};
