#pragma once
/*
* DescText.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Daniel Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtCore/QtGlobal>
#include <QtCore/QString>
//====================================================================================
// Project Includes
//====================================================================================

//====================================================================================
// Local Includes
//====================================================================================
#include "DescGraphic.h"
//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
class DGraphicsTextItem;

class DescText : public DescGraphic
{
private:
  QString text;

public:
  DescText(const QString& descText, qreal descX, qreal descY, qreal descWidth, qreal zOrder, bool locked);
  DescText(RakNet::BitStream& bs);
  DescText(QXmlStreamReader& xml);
  ~DescText(void);

  inline const QString& GetText() const { return text; }

  virtual void Serialise(RakNet::BitStream& bs) const;
  virtual void Serialise(QXmlStreamWriter& xml) const;
  virtual iDGraphicsItem* GetFactory(iContextCallback* callback, Draw* draw);
  virtual inline QString GetStringDesc() const { return QString( "text" ); }

private:
  DGraphicsTextItem* factory;
};
