#pragma once
/*
* ResizeDialog.h
*
* Copyright (C) 2008 Mike Gist, Jan Hosang, Dan Burrell, Dave Lawrence, Andrew Slater
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation (version 2 of the License)
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*/
//====================================================================================
// QT Includes
//====================================================================================
#include <QtGui/QDialog>
//====================================================================================
// Project Includes
//====================================================================================
#include "idgraphicsitem.h"
//====================================================================================
// Local Includes
//====================================================================================

//------------------------------------------------------------------------------------
// Forward Declarations and Preprocessor Definitions
//------------------------------------------------------------------------------------
QT_BEGIN_NAMESPACE
class QPushButton;
class QSlider;

class ResizeDialog : public QDialog
{
  Q_OBJECT
private: iDGraphicsItem* item;
public:
  ResizeDialog(iDGraphicsItem *item, int horizontal, int vertical, int maxH, int maxY);
  void retranslateUi();
  ~ResizeDialog(void);
  QPushButton *buttonResizeDone;
  QSlider *horizontalSlider;
  QSlider *verticalSlider;
  public slots:
    void AdjustHorizontal(int value);
    void AdjustVertical(int value);
    void ResizeEnd();
};
